
import controlP5.*;

ControlP5 cp5;
RadioButton r;

// cell size
int cellWidth = 10;
int cellHeight = 65;

//margin
int rowMargin = 145;
int colMargin = 75;

// matrix to store data
double[][] dataMatrix;
double[][] sortedDataMatrix;
double[][] sortedIndexMatrix;

// create a table to store matrix data
Table myTable;
Table myTableSorted;
Table myTableIndex;

int rowNum, colNum;
int rowNumSorted, colNumSorted;
int rowNumIndex, colNumIndex;

// create a font
PFont myFont;

int[][] colorbrewerG = {
    {237,248,233}, // light
    {199,233,192},
    {161,217,155},
    {116,196,118},
    {65,171,93},
    {35,139,69},
    {0,90,50}, // dark
    {80,80,80} // no data
};

int colorbrewerSelect(double value){
    int selector;
    if (value<0) {
        selector = 7;
    } 
    else if (value>=0 && value<40.77981) {
        selector = 6;
    } 
    else if (value>=40.77981 && value<46.17083) {
        selector = 5;
    }
    else if (value>=46.17083 && value<52.38916) {
        selector = 4;
    }
    else if (value>=52.38916 && value<59.87942) {
        selector = 3;
    }
    else if (value>=59.87942 && value<71.76164) {
        selector = 2;
    }
    else if (value>=71.76164 && value<113.69310) {
        selector = 1;
    } else {
        selector = 0;
    }
     
    return selector;
}

void setup() {
    //set the canvas size to 1280*800, use the PGraphicsRetina2D renderer
    size(1280, 800, "processing.core.PGraphicsRetina2D"); 
    colorMode(RGB); //set the default colormode to RGB
    //frame.setResizable(true); //make the window resizable

    //activate smoothing anti-aliasing functions between pixels
    smooth();
    cp5 = new ControlP5(this);
    r = cp5.addRadioButton("radioButton")
           .setPosition(width-rowMargin+2*cellWidth, 100)
           .setColorForeground(color(120))
           .setColorActive(color(255))
           .setColorLabel(color(255))
           .setSize(20,20)
           .setSpacingRow(10)
           .addItem("Sort",4)
           ;
    //r.activate("000-999");
 
    
    // set the font to size 16 and helvetica, smooth is true
    myFont = createFont("Helvetica", 16, true);
    
    textAlign(CENTER, CENTER);
    
    //read the csv data, ignore the first line (header)
    myTable = loadTable("outputAvg.csv", "header");
    rowNum = myTable.getRowCount();
    colNum = myTable.getColumnCount()-1; //The 1st col is not data
    
    myTableSorted = loadTable("sortedAvg.csv", "header");
    rowNumSorted = myTableSorted.getRowCount();
    colNumSorted = myTableSorted.getColumnCount();
    
    myTableIndex = loadTable("sortedIndex.csv");
    rowNumIndex = myTableIndex.getRowCount();
    colNumIndex = myTableIndex.getColumnCount();

    
    //initialize data matrix
    dataMatrix = new double[rowNum][colNum];
    sortedDataMatrix = new double[rowNumSorted][colNumSorted];
    sortedIndexMatrix = new double[rowNumIndex][colNumIndex];
    
    //copy the table to the datamatrix
    for (int i=0; i<rowNum; i++) {
        //start from the 2nd col, the 1st col is not the data
        for (int j=0; j<colNum; j++) {
            dataMatrix[i][j] = myTable.getFloat(i,j+1);
            //print(dataMatrix[i][j] + " ");
        }
        //println();
    }
    
    for (int i=0; i<rowNumSorted; i++) {
        for (int j=0; j<colNumSorted; j++) {
            sortedDataMatrix[i][j] = myTableSorted.getFloat(i,j);
            //print(dataMatrix[i][j] + " ");
        }
        //println();
    }
    
    for (int i=0; i<rowNumIndex; i++) {
        for (int j=0; j<colNumIndex; j++) {
            sortedIndexMatrix[i][j] = myTableIndex.getFloat(i,j);
            //print(dataMatrix[i][j] + " ");
        }
        //println();
    }
    
    
}


